//+------------------------------------------------------------------+
//|                                                     XY_Array.mqh |
//|                                Copyright 2019, Korotchenko Roman |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2019, Korotchenko Roman"
#property link      "https://www.mql5.com"
#property version   "1.00"
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class CXY_Array
  {
private:

public:
     int length;
      double x[];
      double y[];
                     // CXY_Array();
                     CXY_Array(int N=1);
                    ~CXY_Array();
   int  Resize(int N, int reserveN=0);
   int  CountNonEmty();                        // TO CALCULATE USED ELEMENTS
   void FillByEmpty (double value = EMPTY_VALUE);
   void Clear() { FillByEmpty(); };
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
/*
CXY_Array::CXY_Array()
  {
   length = 0;
  }
*/  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
CXY_Array::CXY_Array(int n) 
  { 
   ArrayResize(x,n); length=ArrayResize(y,n);
  }
//+------------------------------------------------------------------+

CXY_Array::~CXY_Array()
  {
   if(length>0) { ArrayFree(x); ArrayFree(y); length=0; }
  }
//+------------------------------------------------------------------+

int CXY_Array::Resize(int N, int reserveN=0)
{
 ArrayResize(x,N,reserveN); length=ArrayResize(y,N,reserveN); 
 FillByEmpty();
 return length;
}
//+------------------------------------------------------------------+

void CXY_Array::FillByEmpty(double value = EMPTY_VALUE)
{
  for(int i=0; i<length; i++)
  {
    x[i] = y[i] = value;
  }
}
//+------------------------------------------------------------------+

int  CXY_Array::CountNonEmty()
{
  int count= 0;
  while ( x[count] != EMPTY_VALUE ) { count = count+1; }
  return count;
}
//+------------------------------------------------------------------+